<template>
  <div class="subscriptions-orders">
    <div class="subscriptions-orders__radio">
      <ob-radio
          v-for="item in itemOrders"
          :key="item.value"
          :label="item.title"
          v-model="dataSubscription.clients.isAll"
          :valueInput="item.value"
          :disabled="item.disabled"
          class="subscriptions-orders__radio-item"
          @change="changeItem"
      />
    </div>
    <div class="subscriptions-orders__tabs">
      <Tab
          v-for="item in itemsVisible"
          :key="item.uuid"
          :name="item.title"
          icon="role-client"
          :toggle="orders.length !== 1"
          @click="remove(item.uuid)"
      />
      <button
          v-if="itemsHidden.length"
          class="button"
          @click="showOtherItems('show')"
      >
        еще {{ itemsHidden.length }}
      </button>
      <button
         v-if="limit > 10"
          class="button"
          @click="showOtherItems('hide')"
      >
        скрыть
      </button>
    </div>
  </div>
</template>

<script>
  import ObRadio from 'common-components/src/obComponents/obRadio';
  import Tab from './tab';
  import { mapGetters } from "vuex";
  import cloneDeep from 'clone-deep';
  export default {
    name: 'ordersCustom',
    components: {
      ObRadio,
      Tab
    },
    props: {
      subscription: {
        type: Object,
        default: () => {}
      }
    },
    data () {
      return {
        limit: 10,
        itemOrders: [
          {
            value: true,
            title: 'От всех',
            disabled: false
          },
          {
            value: false,
            title: 'Выбрать индивидуально',
            disabled: false
          }
        ],
        dataSubscription: this.subscription
      };
    },
    computed: {
      ...mapGetters({
        listClients: 'subscriptions/listClients',
      }),
      orders () {
        const list = this.subscription.clients.clientUuids;
        const clients = [];
        this.listClients.forEach(key => {
          list.forEach(client => {
            if (client === key.uuid) {
              clients.push(key)
            }
          });
        });
        return clients
      },
      itemsVisible () {
        return this.orders.slice(0, this.limit)
      },
      itemsHidden () {
        if (this.orders.length === this.itemsVisible.length) {
          return [];
        }
        return this.orders.slice(10, this.orders.length);
      },
    },
    methods: {
      showOtherItems (type) {
        if (type === 'show') {
          this.limit = this.orders.length
        } else{
          this.limit = 10
        }

      },
      changeItem (check) {
        if (check) {
          this.$emit('setClients', {
            isAll: true,
            clientUuids: [],
            subscription: this.subscription
          })
        } else{
          this.$emit('showModal')
        }
      },
      remove (uuid) {
        const data = cloneDeep(this.subscription.clients);
        const index = data.clientUuids.findIndex( value => value === uuid);
        if (index !== -1) {
          data.clientUuids.splice(index, 1);
          if (data.clientUuids.length) {
            this.$emit('setClients', {
              isAll: false,
              clientUuids: data.clientUuids,
              subscription: this.subscription
            })
          } else {
            this.$emit('setClients', {
              isAll: true,
              clientUuids: [],
              subscription: this.subscription
            })
          }
        }
      }
    }
  };
</script>

<style scoped lang="scss">
  .subscriptions-orders {
    padding: 0 5px;
    &__radio {
      display: flex;
      &-item {
        margin-right: 14px;
      }
    }
    &__tabs {
      display: flex;
      flex-wrap: wrap;
      margin-top: 9px;
    }
    .button {
      border: none;
      margin: 0 5px;
      padding: 0;
      width: 68px !important;
      overflow: visible;
      background: transparent;
      -webkit-font-smoothing: inherit;
      -moz-osx-font-smoothing: inherit;
      font-size: 14px;
      line-height: 20px;
      color: $color-blue-navy-blue;
      cursor: pointer;
    }
  }
</style>